//+------------------------------------------------------------------+
//|                                                 N&P with Tim.mq4 |
//|                                                  Nick Lougovskoi |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Nick Lougovskoi"
#property link      "http://www.metaquotes.net"

//========================================
// Constant Declarations
//========================================    
//'Manifest Constants' are simply 'Word' substitutes for the specified numbers.
// They are used to make the program more readable.
// Capital letters have been used for these  constants to differentiate them from variables

#define   NUM_CURRENCY_PAIRS 5
#define   NO_ENTRY           0    
#define 	 LONG_ENTRY         1      
#define   SHORT_ENTRY       -1    
#define   NO_POS_OPEN        0  
#define   LONG_POS_OPEN      1    
#define   SHORT_POS_OPEN    -1

                       
//+--------------------------------------------------------+
//|         EXTERNAL PARAMETERS                            |
//| can be set or adjusted by user in properties window    |
//+--------------------------------------------------------+ 
   
   // ** TODO  -  Sorry Nick but would you mind changing the  names of the variables with the _OK suffix to something else.
   // I keep looking at them and thinking they are booleans because of the _OK suffix
   // EUR_USD_TopFilter_Ok could become EUR_USD_TopFilter_Val  or just plain  EUR_USD_TopFilter.
   // I would use the replace function under the Edit tab to do this sort of thing quickly.
   
     extern bool      EUR_USD_BuyFlag   = true;    //Set to true to allow long trading for this currency pair
     extern bool      EUR_USD_SellFlag = true;     //Set to true to allow short trading for this currency pair
     extern double    EUR_USD_TopFilter_Ok;        //Set the value of TopFilterLevel manually on a daily basis for EURUSD
     extern double    EUR_USD_BotFilter_Ok;        //Set the value of BottomFilterLevel manually on a daily basis EURUSD
     
     extern bool      GBP_USD_BuyFlag  =  true;    //true = active, false= deactivated for trading
     extern bool      GBP_USD_SellFlag =  true;    //true = active, false= deactivated for trading
     extern double    GBP_USD_TopFilter_Ok;        //Set the value of TopFilterLevel manually on a daily basis for GBPUSD
     extern double    GBP_USD_BotFilter_Ok;        //Set the value of BottomFilterLevel manually on a daily basis GBPUSD
         
     extern bool      USD_JPY_BuyFlag  =  true;    //true = active, false= deactivated for trading
     extern bool      USD_JPY_SellFlag  = true;    //true = active, false= deactivated for trading
     extern double    USD_JPY_TopFilter_Ok;        //Set the value of TopFilterLevel manually on a daily basis for USDJPY
     extern double    USD_JPY_BotFilter_Ok;        //Set the value of BottomFilterLevel manually on a daily basis USDJPY
      
     extern bool      USD_CHF_BuyFlag   = true;    //true = active, false= deactivated for trading
     extern bool      USD_CHF_SellFlag  = true;    //true = active, false= deactivated for trading
     extern double    USD_CHF_TopFilter_Ok;        //Set the value of TopFilterLevel manually on a daily basis for USDCHF
     extern double    USD_CHF_BotFilter_Ok;        //Set the value of BottomFilterLevel manually on a daily basis USDCHF
      
     extern bool      AUD_USD_BuyFlag   = true;     //true = active, false= deactivated for trading
     extern bool      AUD_USD_SellFlag  = true;     //true = active, false= deactivated for trading
     extern double    AUD_USD_TopFilter_Ok;         //Set the value of TopFilterLevel manually on a daily basis for AUDUSD
     extern double    AUD_USD_BotFilter_Ok;         //Set the value of BottomFilterLevel manually on a daily basis for AUDUSD

     extern double Lots = 0.01 ;   // The default value is set to 0.01. The user can change it to whatever is required in the properties window.
     extern bool DEBUG_ON = true;  // This turns on the debug comments for testing and problem solving
     extern int TakeProfit = 20;   // TakeProfit Stop In pips.
  
   

//+------------------------------------------------------------------+
//| Global Parameters                                                |
//| These values can be read or changed from anywhere in this        |
//| program but not by the user from the properties box              |
//+------------------------------------------------------------------+


   string CurrencyPair[NUM_CURRENCY_PAIRS] = {"EURUSD","GBPUSD","USDJPY","USDCHF","AUDUSD"};  // Array declared and initialised with currency pair strings.
   double TopFilters[NUM_CURRENCY_PAIRS];    // Array declared but holds no usefull data. It will be initialised with number =  zero.
   double BotFilters[NUM_CURRENCY_PAIRS];    // ditto for this array.
   bool   Buy_Flags[NUM_CURRENCY_PAIRS];     // Array declared but holds no usefull data. It will be initialised with boolean  = false.
   bool   Sell_Flags[NUM_CURRENCY_PAIRS];    // ditto for this array.


//+------------------------------------------------------------------+
//|                 INIT function                                    |
//| Expert initialization function                                   | 
//| It can be used to initialise parameters etc                      |      
//|                                                                  |
//+------------------------------------------------------------------+
int init()
  {

    if (DEBUG_ON)
      Print("*** Debug *** init()"); // If the global debug flag is turned on a message will be printed to the log file.

// The following arrays, which have already been declared 'Globally" are initialised,i.e filled with data here
// This is done here in the  init function instead of in the start function because it only needs to be done when the program starts up.
// As a result the program will run faster because it is not continuously repeating something that only needs to be done once.

   TopFilters[0]  =  EUR_USD_TopFilter_Ok;
   TopFilters[1]  =  GBP_USD_TopFilter_Ok;
   TopFilters[2]  =  USD_JPY_TopFilter_Ok;
   TopFilters[3]  =  USD_CHF_TopFilter_Ok;
   TopFilters[4]  =  AUD_USD_TopFilter_Ok;
   
   BotFilters[0]  =  EUR_USD_BotFilter_Ok;
   BotFilters[1]  =  GBP_USD_BotFilter_Ok;
   BotFilters[2]  =  USD_JPY_BotFilter_Ok;
   BotFilters[3]  =  USD_CHF_BotFilter_Ok;
   BotFilters[4]  =  AUD_USD_BotFilter_Ok;
   
   Buy_Flags[0]   =  EUR_USD_BuyFlag;
   Buy_Flags[1]   =  GBP_USD_BuyFlag;
   Buy_Flags[2]   =  USD_JPY_BuyFlag;
   Buy_Flags[3]   =  USD_CHF_BuyFlag;
   Buy_Flags[4]   =  AUD_USD_BuyFlag;
   
   Sell_Flags[0]  =  EUR_USD_SellFlag;
   Sell_Flags[1]  =  GBP_USD_SellFlag;
   Sell_Flags[2]  =  USD_JPY_SellFlag;
   Sell_Flags[3]  =  USD_CHF_SellFlag;
   Sell_Flags[4]  =  AUD_USD_SellFlag;
                                                 

   return(0);
  } // End of INIT function
  
  
//+------------------------------------------------------------------+
//|                 DEINIT function                                  |
//| Expert deinitialization function                                 | 
//| This function is called once when the EA is deleted from a chart |
//| It can be used to do clean ups such as closing files etc.        |      
//| It is often unused.                                              |
//+------------------------------------------------------------------+

int deinit()
  {

   if (DEBUG_ON)
      Print("*** Debug *** deinit()"); // If the global debug flag is turned on a message will be printed to the log file.
  
   
   return(0);
  } // End of DEINIT function
  

//+------------------------------------------------------------------+
//|                 START function                                   |
//| This is the main function that is called each 'tick' providing   |
//| the program isn't already busy. As this function is typically    |
//| called  many times a minute we need to be carefull with what     |
//| we do here. It is quite easy to use up a lot of                  |
//| computer resources if we are not carefull.                       | 
//|                                                                  |
//+------------------------------------------------------------------+

int start()                  
  {
    string currSymbol;        // These are local variables that are are declared each time the function is called. They are valid 
                              // only within this function. Note that we have used lower case letters to start local variable names
                              // to help diferentiate them from global variables.     
    double topFilt;     
    double botFilt;    
    int  entryStatus;
    bool buyFlag;
    bool sellFlag;
     
    for (int c=0;c<NUM_CURRENCY_PAIRS;c++) // For each currency pair, loop through the entire block of code within the curly brackets '{' & '}' 
    { // start of loop
        currSymbol = CurrencyPair[c];      //For each iteration of this block we extract one currency pair 
                                           //from the global array and assign it to a local variable 
        buyFlag  = Buy_Flags[c];           //We also select flag and filter values for this curreny pair from the Global Arrays
        sellFlag = Sell_Flags[c];          // and assign these values to local variables also.
        topFilt = TopFilters[c];
        botFilt = BotFilters[c];   
        
        entryStatus = EntryRules (currSymbol, topFilt, botFilt);  //Call to the entry rules function
                                                                 // passing it three local variables as its function parameters                                                                      
       
        // entryStatus is an integer value returned by the EntryRules function.
        // We could just say if (entryStatus == 1...etc but using the manifest constant LONG_ENTRY which has been assigned a value of 1
        // makes it a lot easier to see what is happening.
         
        if (entryStatus == LONG_ENTRY  && buyFlag  && NoLongPositionsOpen(currSymbol))  
        { 
           // Call to MT4 standard function OrderSend for buy order, passing it a variety of parameter values 
           // Global variables, local variables, MT4 Constants, MT4 predefined variables and string literals such as "Sell", "Buy" etc
           
           OrderSend(currSymbol,OP_BUY,Lots,Ask,0,0,Bid+TakeProfit*Point,"Buy",001,0,Green);    
           //TODO Error checking and handling required here   
        }
        
        if (entryStatus == SHORT_ENTRY  && sellFlag  && NoShortPositionsOpen(currSymbol))
        {
           // Call to MT4 standard function OrderSend for sell order.
           // Some different parameter values  are passed to this function to execute a SELL order as compared to the previous BUY order 
           OrderSend(currSymbol,OP_SELL,Lots,Bid,0,0,Ask+TakeProfit*Point,"Sell",002,0,Red);
           //TODO Error checking and handling required here
        }

    
        if (DEBUG_ON)  //if the global debug flag is turned on, this debug information will be
                       //printed to the log file for each currency pair as it is processed in the 'for loop'
        // if (1==2)  Uncommenting this line it will turn off this particular debug statement.            
           // if (entryStatus != 0)   // Uncomment this line to only print debug information when a buy or sell signal occurs.
                    Print("*** Debug *** start() function.",
                  "   currSymbol : ", currSymbol,
                  "   topFilt : ", topFilt,
                  "   botFilt : ", botFilt,
                  "   buyFlag : ", buyFlag,
                  "   sellFlag : ", sellFlag,
                  "   entryStatus : ", entryStatus);
                                             
        
   }  // end of for loop 

} // End of START function
 
 
//+-------------------------------------------------------------------+
//|                                                                   |
//|                 ENTRY RULES  function                             |
//| Check if a BUY or SELL condition exists for a specified           |
//| currency pair                                                     |
//|                                                                   |
//+-------------------------------------------------------------------+

int EntryRules(string Currency_Sym, double Top_Filter, double Bot_Filter)
{
// Note that Currency_Sym, Top_Filter and Bot_Filter are parameter values passed to the function.
// These parameter values have been given different names to either global or local variables.
// They can be used withing the function, just like variables.
// They will hold whatever values have been passed to them when the function was called.
// Function parameters CAN be given the same names as variables and they will work fine but it may lead to human confusion.


// Local variable declarations. They are only valid within this function.
    double emas_Up, emas_Down;    
    double ema7;    
    double ema14;
    double sma50;
    int result = NO_ENTRY;  // A local integer (int) variable to return as the result. It is assign an initial value of NO_ENTRY
                   
    ema7=iMA(Currency_Sym,PERIOD_M5,7,0,MODE_EMA,Close,0);   //TODO Runtime bugs here -- Suggest carefully checking documentation
    ema14=iMA(Currency_Sym,PERIOD_M5,14,0,MODE_EMA,Close,0);   
    sma50=iMA(Currency_Sym,PERIOD_M5,50,0,MODE_SMA,Close,0); 
 
    emas_Up =  (ema7>ema14) && (ema14>sma50);
      if (emas_Up && Ask < Top_Filter) 
         result = LONG_ENTRY;   // We have assigned the manifest constant to the local variable result 

       emas_Down  =  ema7<ema14 && ema14<sma50;
      if (emas_Down &&  Bid > Bot_Filter)
         result = SHORT_ENTRY;   

      if (DEBUG_ON)
       // if (1==2)  Uncommenting this line it will turn off this particular debug statement.
       // Sometimes you can get too much information in the log file 
       //    if (result != NO_ENTRY)  // If I uncomment this line it will only display when there is a short or long entry signal
              Print("*** Debug *** EntryRules() function.",
                    "   Currency_Syn : ", Currency_Sym,
                    "   ema7 : ", ema7,
                    "   ema14 : ",ema14,
                    "   sma50 : ", sma50,
                    "   Top_Filter :", Top_Filter,
                    "   Ask : ", Ask, 
                    "   Bot_Filter :",Bot_Filter,
                    "   Bid : ", Bid,
                    "   result : ", result);
               
       
      
       return(result);  // Finally, we return the local variable result which will have been assigned a value of 
                        //  NO_ENTRY, LONG_ENTRY or SHORT_ENTRY depending on the above logic
      
                 
 }  
 // End of Entry Rules function
          
          
  
//+-------------------------------------------------------------------+
//|                                                                   |
//|        NO LONG POSITIONS OPENS  function                          |
//|                                                                   |
//|        This function checks to see if we have any LONG (BUY)      |
//|        orders open for any specified currency which is passed     |  
//|        to the function as a string parameter.                     |  
//|        The function returns a  boolean "Flag" which is set to     |
//|        true if a long open order exixts for the currency pair.    |
//|        Otherwise it returns false.                                |
//|                                                                   |
//+-------------------------------------------------------------------+

    bool NoLongPositionsOpen(string CurrencySymbol)
    {
       int total;
       int pos;
       bool noOpenPosition = true;
     
       total=OrdersTotal();
       for(pos=0;pos<total;pos++)
       {
         if(OrderSelect(pos,SELECT_BY_POS, MODE_TRADES)==true)
           if (OrderSymbol() == CurrencySymbol &&  // We have an order that matches the value in the parameter passed to this function
               OrderType() == OP_BUY)    // The order is a buy 
             {  
               noOpenPosition = false;  // so we DO have an open position;
               break;  // no point in looking any further 
             }          
       }
       return(noOpenPosition);   // returns a logical true or false value
   
    } // End of NoLongPositionsOpen function
   
   
//+-------------------------------------------------------------------+
//|                                                                   |
//|        NO SHORT POSITIONS OPEN  function                          |
//|                                                                   |
//|        This function checks to see if we have any SHORT (SELL)    |
//|        orders open for any specified currency which is passed     |  
//|        to the function as a string parameter.                     |  
//|        The function returns a  boolean "Flag" which is set to     |
//|        true if a long open order exixts for the currency pair.    |
//|        Otherwise it returns false.                                |
//|                                                                   |
//+-------------------------------------------------------------------+
              
    bool NoShortPositionsOpen(string CurrencySymbol)
    {
       int total;
       int pos;
       bool noOpenPosition = true;
     
       total=OrdersTotal();
       for(pos=0;pos<total;pos++)
       {
         if(OrderSelect(pos,SELECT_BY_POS, MODE_TRADES)==true)
           if (OrderSymbol() == CurrencySymbol &&  // We have an order that matches the value in the parameter passed to this function
             OrderType() == OP_SELL)    // The order is a sell
             {  
               noOpenPosition = false;  // so we DO have an open position;
               break;  // no point in looking any further 
             }          
       }
       return(noOpenPosition);  // returns a logical true or false value
    
    } // End of NoShortPositionsOpen function
      


          
          
          
//+-------------------------------------------------------------------+
//|                                                                   |
//|        APPENDUM                                                   |
//|                                                                   |
//|        Additional Documentation, comments, notes etc              |
//|        TODO  - Tidy these up                                      |  
//|                                                                   |
//|                                                                   |
//+-------------------------------------------------------------------+      
       
          
 //***Entry Rules Function         
          
     //***     If   the  7 Period Exponential Moving Average is less than 14 Period Exponential Moving Average 
      //***     the 14 Period Exponential Moving Average is less than the 50 period Simple Moving Average     
      //***     Current Price   is more than  BottomFilterLevel  THEN
      //***     THEN
      //***     Signal a  SELL (Short) entry condition
          
          
          
    //*** HAS BEEN DONE - The code for this function                    
//int EntryRules() // Parameter declarations for the function go between the brackets()
                   // Parameters are declared the same way as variables. Multiple parameters should be separated by commas. 
                   // for example - int MyFunction(string MyText, int MyNumber, bool MyFlag)      
          
          
          
    //my initial thinking is below for CHECKING ORDERS FUNCTION, but Tim redesigned the code
    //this must be tied to code above i.e. [c] so that we stick to each pair
    // this should be outside of start function, and will be called within start function
    //this must return either 1= Long on Market, -1 = Short on Market, 0 = No position opened, for the currency pair in question
    //PseudoCode: 1. Check if currencySymbol has LONG or SHORT position, 2. If long = return 1, short return -1.
    //we need 2 separate functions becase we should be able to enter in both directions (eg: even if 1 Long exists, we still want to enter short). If we only have 1 function for this then it would return 1 value, and this would be wrong (in my opinion).
   
   
   
   /*
    int Order_Check_Buys (int c)
    {
     int result = 0;
     if (OrderSelect (c,SELECT_BY_POS,MODE_TRADES)==true)        //this checks if an open order exists, it doesn't check direction
     if (OrderType () ==OP_BUY) result ++;
     return(result);
    }
    
    int Order_Check_Sells (int c)
    {
    int result = 0;
    if (OrderSelect (c,SELECT_BY_POS,MODE_TRADES)==true);
    if (OrderType () ==OP_SELL) result ++;
    return (result)
    }
    */
    
    // ** Good try Nick but not quite. When you are trying to code up something "tricky" like this the easiest way is usually to try
    // ** and find some existing code which does the job or is similar and can be modified. Do try however, to understand how the code works befor you use it.
    // These functions  are so similar that we could easily write them as a single function and just pass the single function  an additional BUY or SELL paramter.
    // The way you have done it is OK though and it lends itself to a neat way of calling from the start function.
   
            
          
          
   
//-------------------------Declaring EMA's so we can use them in EntryRules function 

  
   //  entryStatus = EntryRules(); //*** TODO Pass this function some parameters between the brackets;
       
       // int nobuysonmarket = Order_Check_Buys (c);  //calling Order_Check... functions, not sure if I defined the parameter right).
          
                                                      // ** Not quite. c is just the index number.
                                                      // you need to pass the currency symbol to the function. If you pass the index value "c" to the function
                                                      // you need to access the symbol array CurrencyPair[c] inside the function to retreive the required currency pair.
                                                      // While this would work fine, to my mind it makes the code unnecessarily complex.
                                                      
       // int noshortsonmarket = Order_Check_Sells (c);
                                                                                
     
        
      //  if (entrystatus ==1 && buyFlag == 1 && nobuysonmarket <=0)

                                  //*** Make sure that the parameters are also declared in the code for the function.
                                    //**TIM: I don't understand this bit. We can't just put the 3 names into the brackets, can we? Why would we do that?

//  **** Yes we can just put the 3 names into the brackets provided they are defined in the actual function itself
//  **** for example  entryStatus = EntryRules(currencySymbol, topFilter,botFilter)

//  **** Nick When you call OrderSend(symbol(),OP_BUY,Lots,Ask,0,0,Bid+TakeProfit*Point,"Buy",001,0,Green) you are calling a predefined function. You pass parameters to the
// function which tells it what to do. The function does "its thing"and often it returns a value. In the case of the OrderSend() function it will return a ticket number 
// if the function call is succesfull. If the function call is not succesfull it will return  a negative number telling you what sort of error has occured.
// i.e
//   ticketNumber = OrderSend(symbol(),OP_BUY,Lots,Ask,0,0,Bid+TakeProfit*Point,"Buy",001,0,Green)
//   if (ticketNumber < 0)  
//        An Error has occured
 
//
// What we are doing with EntryRules is creating our own function which will check our entry rules for any given currency pair and return a Buy, Sell, or NoEntry result
// We will want to pass our EntryRules function parameters for currency pair, top filter and bottom filter. It will then, hopefully return us a one of three values
// i.e  LONG_ENTRY, SHORT_ENTRY, NO_ENTRY 



//----------------------------------------------------------------------------------------------------------+
       
    
      
        //*** We now call the EntryRules fuction which at the moment is just an empty shell with some coments in it
        //*** We are going to pass some parameters to this function and  get it to return to us  one of three
        //*** possible values NO_ENTRY, LONG_ENTRY ,SHORT_ENTRY       
       
       
        //If    there is no open BUY position  for this currency pair   AND
        //      a BUY condition exixts for this currency pair           AND
        //      the BuyFlag is set true for this currency pair
        //      THEN   
        //          Open a BUY Position  for this currency pair
	     //          USING  Last Ask Price, Pre-determined Lot size, Pre-Determined Profit Stop Amount

        //If    there is no open SELL position  for this currency pair   AND
        //      a SELL condition exixts for this currency pair           AND
        //      the SellFlag is set true for this currency pair
        //      THEN   
        //          Open a SELL Position  for this currency pair
	     //          USING  Last Bid Price, Pre-determined Lot size, Pre-Determined Profit Stop Amount
         
          
          
     
       // int nobuysonmarket = Order_Check_Buys (c);  //calling Order_Check... functions, not sure if I defined the parameter right).
          
                                                      // ** Not quite. c is just the index number.
                                                      // you need to pass the currency symbol to the function. If you pass the index value "c" to the function
                                                      // you need to access the symbol array CurrencyPair[c] inside the function to retreive the required currency pair.
                                                      // While this would work fine, to my mind it makes the code unnecessarily complex.
                                                      
       // int noshortsonmarket = Order_Check_Sells (c);
                                                                                
     
        
      //  if (entrystatus ==1 && buyFlag == 1 && nobuysonmarket <=0)

          
          
          

          
          //***TIM: So in brackets we only put global variables, because we call these to use with this function. Right?
          //Answer. The variables in the brackets belong to the function. They are function parameters but are defined in the same was as ordinary
          //        program variables. They are used to pass specific values, which may be and often are in the form of other variables to the function.
          //        The function like wise returns an integer value (int) in the return statement. If a function doesn't return any value it is declared as
          //        type void    i.e void EntryRules()  A function declared like this requires no parameters and  returns no result.
          //
          //        Now you may well ask. What would be the use of such a function?
          //
          //        Well a function im MT4 can directly read values from global variables and directly write to or change the values in global variables.
          //        BUT... We need to be very carefull doing this as we can quickly turn our nicely structured code into mush. MT4 is a fairly simple language
          //        as far as structure is concerned and sometimes, directly accessing global variables from within a function can not be avoided. MT5 may change this 
          //        but probably at a cost of making MT5 more difficult for newbies to use and learn.
          //   
          //        topFilterOk and botFilterOk are no longer defined as local variables. I commented them out for you :). Instead we access the parameters passed
          //        to the function i.e TopFilter * BottomFilter 
          //
          //        One final point. It is considered good practice to only exit the function at one point at its end. That means having only one return statement
          //        Again this can sometimes be impractical to achieve but it is quite easily accomplished in this case by simply introducing another 
          //        local variable which I have called result. 
          //     
          //        Also please note that I changed the function parameter name CurrencySymbol to CurrencySym buecause we have currencySymbol defined as a local 
          //        variable in the main start routine. While this is perfectly "legal" I thought that the similar names might confuse you.
          //
          //        

 
 
      
     //***Old code from EntryRules function commented out so you can compare it with modified code if you want to
   //    emas_Up    =  ema7>ema14 && ema14>sma50;
    //   emas_Down  =  ema7<ema14 && ema14<sma50;
   
   //    topfilterok = Ask < topFilter;
     //  botfilterok= Bid > botfilters;
    
    //  if (emas_Up && topfilterok)
      //{
    //      return(1)                     // 1= Long Entry, 0=No Entry, -1= Short Entry
     // }
     // if (emas_Down && botfilterok)
     // }
     //    return(-1)
     // {
    
                        

   


 
   
//------If (works) = celebrate !--------------------------------------------- 
   

//------------------------------------------------------------------------------------------------------------+
//                                                                                                            +
//                       List of Actions & Questions done by Nick 21 June 09                                  +
//                                                                                                            +
//------------------------------------------------------------------------------------------------------------+
//
// 0. Re-organised comments within the code to make it easier to follow (moved things into archive of comments at end)
// 1. Moved CurrencyPair array into init function (I assume that was better than it being outside of init, because you suggested other arrays to move into 
// 2. Created an Array for Flags and Filters in init function,
// Q: Why don't we say in the [] next to the array name the number of variables involved (eg: 5, etc)? Isn't that what its for?
// 3. Tried to set a global parameter next to the array sizing, called NumCurrencyPairs. Don't know what you mean by this Tim or how it's done? Help.
// TQ:*** A thought! Would a manifest constant for the number of currency pairs simplify things a bit? A: I'm planning to expand the strategy to more pairs shortly after I gather enough test data on it. So let's keep it as it is to simply things for me.
// 4. Search for #2# Question: Do we need to use the for count function for each array, or is there a different way to do it Tim? I still don't know how to implement this.
// 5. Created local variables sellflags, buyflags, topfilters, botfilters,
// TQ: #3#
// TQ: #4#
// 6. Working on int EntryRules function. Had to start by declaring ema's on a more global level so they call up the arrays.
// 7. Working on CountBuys condition, couldn't figure it out.
// 8. Working on OrderSend and what it's dependent on, I think I got about 80% of it. Please do check.


//------------------------------------------------------------------------------------------------------------+
//                                                                                                            +
//                       Answers to questions 22 June 09                                                      +
//                                                                                                            +
//------------------------------------------------------------------------------------------------------------+
//Q1: Why don't we say in the [] next .....
//A. The simple way to declare an array is as you suggest  ie CurrencyPair[5]. This is a STATIC ARRAY that will hold the same number of elements
//   throughout the running of the program. We could then replace the number 5 with a manifest constant #define NUM_CURRENCY_PAIRS 5 
//   and then define the array CurrencyPair[NUM_CURRENCY_PAIRS]. 
//   You would also define the other arrays the same way i.e TopFilters[NUM_CURRENCY_PAIRS].
//   When the compiler sees NUM_CURRENCY_PAIRS in the code it simple substitues the number 5 for the word NUM_CURRENCY_PAIR.
//   Sometimes, but not in this case we dont know how many elements we want to store in an array. For example let us say we declare an array for WinningTrades.
//   Then we might typically declare an empty array using  WinningTrades[] and use functions like ArrayResize() and ArraySize() to work with this DYNAMIC ARRAY.


// #4# Question Tim: Why don't we assign the constants to the words with '='? How can we use this in the future?
// A. A constant is not a variable. A Constant cannot be changed by the program. A Variable can. Using Constants for values that dont need to be changed by the program
//    is safer. The programmer of course can change this value at any time and this value will then be reflected throughout the program. It is much easier and less prone
//    to error than hunting through the program, trying to look for and change individual numbers.



                                       //---------------------------------------------------------------+
                                       //                                                               |
                                       //     Archive:   Useful Tips by Tim                             |
                                       //                                                               |
                                       //---------------------------------------------------------------+                                               
 
// *** Nick can we just skip all the rest of this stuff for the time being until we get the EntryRules function sorted out?
// *** It should all become a bit clearer then 

//--------------------------Check to see if  there is already  an open  BUY  position for this Currency Pair
//
 
  /*
   int CountBuys()           
      {
       int buys = 0;       //***TIM: This is the only way I know how to do something like this, and I don't even know how to do this really. Help.
       for (int i=0;i<OrdersTotal();i++)
         {
          if (OrderType(symbol)==OP_BUY)buys[symbol]++
       //I know this is totally wrong, can't figure it out.
       }  
       
    // I'm sorry but MT4 and most other languages wont support this sort of logic
    // You have to use logic like
    //   emasUp =  ema7 > ema14   &&  ema14 > sma50;     
    
   // void EntryRules()  //***  I changed the entry rules  from void - meaning nothing is returned by the function to int - meaning 
                      //***  the function returns an integer value.
                      //***  We want this function to return one of three possible values -  NO_ENTRY, LONG_ENTRY ,SHORT_ENTRY
                      //***  These return values have been declared as manifest constants at the top of the program. 
                      //**** These constant declarations are global which means that they can be used anywhere in the program.
  */ 
    
                                                
  //*** No it is better to put them in the entry rules function where they are needed. I have moved them there  
//   ema7=iMA(symbol,PERIOD_M5,0,MODE_EMA,Close,0);
//   ema14=iMA(symbol,PERIOD_M5,0,MODE_EMA,Close,0);
//   sma50=iMA(symbol,Period_M5,0,MODE_SMA,Close,0);
  //#3#***Question Tim: Can we hit 2 stones with 1 bullet, declare and assign at the same time, eg: 'double botfilters=BotFilters[c]'
     
     // A. Yes you can do this and people will argue constantly about what is "best practice".  In my opinon  it is usually better to declare the variables at the top of a function
     //    or in a global block as the case may be and then assign values latter.
     //    My underlying philosophy is that you should always make it easy for the other guy to be able to read or debug your code even if it requires a bit more typing.
     //    Writing crypyic code is not clever and it leads to endless frustration for others who may need to modify or maintain your code after you have finished with it
     //    Cryptic code can also bite you in the bum when you revisit a piece of code that you wrote some time ago and can't figure out what you did or why you did it.

  
  
  // int count = ArraySize(CurrencyPair);                     //I'm not sure if this goes here or if it is a local?
                                                   // The variable count here is local to the init function.
                                                   // We would have to declare count as a global variable if we wanted to reference it from elsewhere in the program
                                                   // We could then call the ArraySize function here to correctly initialise the count variable
                                                   // As I think you are starting to realise, it is much simpler to just declare fixed (static) arrays 
                                                   // using a manifest constant to define their size.
                                                   // We can do this in this case becuase we already know that the array will hold 5 element 
   
 
  // The following won't work because we are trying to assign VARIABLE values. When we compile our code the program has no idea what values the
  // user is going to place in these variables
                                                                                                                                           
  // double TopFilters[]   = {EUR_USD_TopFilter_Ok, GBP_USD_TopFilter_Ok,USD_JPY_TopFilter_Ok,USD_CHF_TopFilter_Ok,AUD_USD_TopFilter_Ok};
  // double BotFilters[]   = {EUR_USD_BotFilter_Ok,GBP_USD_BotFilter_Ok,USD_JPY_BotFilter_Ok,USD_CHF_BotFilter_Ok,AUD_USD_BotFilter_Ok};
  // bool Buy_Flags[]    = {EUR_USD_BuyFlag,GBP_USD_BuyFlag,USD_JPY_BuyFlag,USD_CHF_BuyFlag,AUD_USD_BuyFlag};
  // bool Sell_Flags[]   = {EUR_USD_SellFlag,GBP_USD_SellFlag,USD_JPY_SellFlag,USD_CHF_SellFlag,AUD_USD_SellFlag};
                                                   
 
    
   //string CurrencyPair[] = {"EURUSD","GBPUSD","USDJPY","USDCHF","AUDUSD"};  // Ths works OK for the CurrencyPair array because we are assigning
                                                                            // CONSTANT string values. by this tim meant [1] &, we need to build an array
                                                 
                                                //Alternatively we could just use a fixed 5 
                                                //***   slot array and use a manifest constant to define it.
                                                //****  As it is not going to change in size a dynamic array is really overkill in this situation.
                                                //****  At the moment we are reinitializing the array every tick and this uses up unnecessary 
                                                //****  computer power. Too much inefficient coding can result in a slow running program which becomes 
                                                //****  particularly noticable when running optimizations. This is something that you must keep in
                                                //****  mind when writing larger or more complex programs.
                                        
//*** The following line has been moved down a few lines to the global parameters area
   //*** This was done because it is not an external parameter. I'm just trying to keep things "neat and tidy :)"   
   //  string CurrencyPair[] = {"EURUSD","GBPUSD","USDJPY","USDCHF","AUDUSD"}; //***Global Declaration of Array 'Pair' so we can call it in 'start' function
   //TIP FOR Me: Variables declared here (ie outside of start function
   //will preserve their value with each tick (hence we can't declare ema's here, etc. 
   //they are called Global variables, local variables are within functions

//*** Try to use local variables as much as possible as it keeps the program more modularised and helps prevent bugs**understood**
                        //*** Notice that I have started these local variable names with lower case letters. 
                        //*** This makes them more easily recognizable as local variables as compared to global variables whose names I start 
                        //*** with Upper Case letters. **got it**  
                        //*** These items i.e. symbol and entrystatus, are called local variables. They are only valid inside the function in which 
                        
                        
                                                //****  This will work but this array sizing only needs to be done once when the program starts up.
                                                //****  It is therefore better to place the array sizing into the init function and use it to set a
                                                //****  global parameter that we could call NumCurrencyPairs. 
                                       
   
                                                //After this I don't know how to use this, i guess we substitute OrderSend(Symbol)
                                                //part with the array name so it loops through that. is that so?        
                                              
    // *** Yes that is so and a bit more.  
    //*** I have added some curly brackets to the entire block so that the FOR LOOP now applies to the whole block i.e everything inside the curly brackets.    
    
      //*** TODO
        //*** First we will need to handle the top amd bottom filter levels for the  currency pairs
        //*** There is a number of ways of going about this. Perhaps the most straightforward is to use some more arrays and initialize them 
        //*** in the init function with the external parameter values. make sure you keep them all in the same order as the currency pair arrays   
        //*** and note that the first element in the array is [0] not [1]
        //*** You may as well set up the buy/sell flags in the same way while you are at it.


    // TODO 22 Jun 09
    // Set up the rest of the arrays as shown in the init function  ***Done
    // Complete the coding of the  EntryRules function noting how calling parameters are defined and used
    // in the start (main) function, 
    
   
    // TODO 23 Jun 09 
    // put the call to the entry rules function inside the currency loop and pass it some parameters as shown/described
    // Compile the code and then use the strategy tester, log files and debug statements to test what we have done so far
    // you should be able to see the Long, Short  &  No_entry signals in the log file.



